﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirFighter
{
    internal class AircraftCompareByColor : IComparer<IDrawingObject>
    {
        public int Compare(IDrawingObject? x, IDrawingObject? y)
        {
            var xAirFighter = x as DrawingObjectAirFighter;
            var yAirFighter = y as DrawingObjectAirFighter;

            if (xAirFighter == null && yAirFighter == null) return 0;
            if (xAirFighter == null) return 1;
            if (yAirFighter == null) return -1;

            string xColor = xAirFighter.GetAirFighter.AirFighter.BodyColor.Name;
            string yColor = yAirFighter.GetAirFighter.AirFighter.BodyColor.Name;

            if (xColor != yColor) return xColor.CompareTo(yColor);

            var speedCompare = xAirFighter.GetAirFighter.AirFighter.Speed.CompareTo(yAirFighter.GetAirFighter.AirFighter.Speed);
            if (speedCompare != 0) return speedCompare;

            return xAirFighter.GetAirFighter.AirFighter.Weight.CompareTo(yAirFighter.GetAirFighter.AirFighter.Weight);
        }
    }
}
