﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirFighter
{
    internal class AircraftCompareByType : IComparer<IDrawingObject>
    {
        public int Compare(IDrawingObject? x, IDrawingObject? y)
        {
            var xAirFighter = x as DrawingObjectAirFighter;
            var yAirFighter = y as DrawingObjectAirFighter;

            if (xAirFighter == null && yAirFighter == null) return 0;
            if (xAirFighter == null) return 1;
            if (yAirFighter == null) return -1;


            if (xAirFighter.GetAirFighter.GetType().Name != yAirFighter.GetAirFighter.GetType().Name)
            {
                if (xAirFighter.GetAirFighter.GetType().Name == "DrawingAirFighter")
                {
                    return -1;
                }
                return 1;
            }

            var speedCompare = xAirFighter.GetAirFighter.AirFighter.Speed.CompareTo(yAirFighter.GetAirFighter.AirFighter.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xAirFighter.GetAirFighter.AirFighter.Weight.CompareTo(yAirFighter.GetAirFighter.AirFighter.Weight);
        }
    }
}
