﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirFighter
{
    internal class DrawingObjectAirFighter : IDrawingObject
    {
        private DrawingAirFighter _airFighter = null;
        public DrawingObjectAirFighter(DrawingAirFighter airFighter)
        {
            _airFighter = airFighter;
        }

        public DrawingAirFighter GetAirFighter => _airFighter;

        public float Step => _airFighter?.AirFighter?.Step ?? 0;
        public (float Left, float Right, float Top, float Bottom)
       GetCurrentPosition()
        {
            return _airFighter?.GetCurrentPosition() ?? default;
        }
        public void MoveObject(Direction direction)
        {
            _airFighter?.MoveTransport(direction);
        }
        public void SetObject(int x, int y, int width, int height)
        {
            _airFighter.SetPosition(x, y, width, height);
        }
        public void DrawningObject(Graphics g)
        {
            // TODO
            _airFighter.DrawTransport(g);
        }
        public string GetInfo() => _airFighter?.GetDataForSave();
        public static IDrawingObject Create(string data) => new DrawingObjectAirFighter(data.CreateDrawingAirFighter());

        public bool Equals(IDrawingObject? other)
        {
            var otherObj = other as DrawingObjectAirFighter;
            if (otherObj == null) return false;

            var airFighter = _airFighter.AirFighter;
            var otherAirFighter = otherObj._airFighter.AirFighter;

            if (airFighter.Speed != otherAirFighter.Speed) return false;
            if (airFighter.Weight != otherAirFighter.Weight) return false;
            if (airFighter.BodyColor != otherAirFighter.BodyColor) return false;

            // TODO доделать проверки в случае продвинутого объекта

            if(airFighter.GetType().Name != otherAirFighter.GetType().Name)
            {
                return false;
            }

            if(airFighter.GetType().Name == "EntityAirFighter") return true;

            var modernEntity1 = (EntityModernAirFighter) airFighter;
            var modernEntity2 = (EntityModernAirFighter) otherAirFighter;

            if (modernEntity1.DopColor.Name != modernEntity2.DopColor.Name) return false;
            if (modernEntity1.Rockets != modernEntity2.Rockets) return false;
            if (modernEntity1.DopWings != modernEntity2.DopWings) return false;

            return true;
        }
    }
}
